/*************************************************************************\
* Copyright (c) 2002 The University of Chicago, as Operator of Argonne
* National Laboratory.
* Copyright (c) 2002 The Regents of the University of California, as
* Operator of Los Alamos National Laboratory.
* This file is distributed subject to a Software License Agreement found
* in the file LICENSE that is included with this distribution. 
\*************************************************************************/
/* viewImageMain.c */

/* viewImage.c,v 1.4 2002/07/23 19:18:23 jba Exp */
/************************DESCRIPTION***********************************
  EPICS Array Record Image Viewer 
**********************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <Xm/Xm.h>

#include "epicsVersion.h"

#include "viewImageVersion.h"
#include "viewImageGui.h"

/* globals */

/* forward declarations */
static void printUsage(char *pgm);

/******************************************************
  main
******************************************************/
int main(int argc,char *argv[])
{
    int i;
    char *systemName=0;

    /* Initial the gui and X command line options*/
    viewImageGuiInitApp(&argc,argv);

    /* Display error message for unused options */
    if(argc>1) {
        for(i=1;i<argc;i++){
            if(strncmp("-V",argv[i],2)==0){
                fprintf(stderr,"%s \n",APP_VERSION_STRING);
                if (i==(argc-1)) return 0;
            } else {
                if (strcmp(argv[i],"-help")==0){
                   printUsage(APP_NAME);
                   return(0);
                }
                if ((strncmp("-",argv[i],1)==0)) {
                   fprintf(stderr,"%s: Invalid option: %s\n",APP_NAME,argv[i]);
                   /*errDialog("Invalid option: %s\n",argv[i]);*/
                }
            }
        }
        if ((strncmp("-",argv[argc-1],1)==0)) {
            fprintf(stderr,"%s: Insufficient arguments\n",APP_NAME);
            /*errDialog("Insufficient arguments: %s\n",APP_NAME);*/
            printUsage(APP_NAME);
            return(0);
        } else {
            systemName=(char *)XtCalloc(strlen(argv[argc-1])+1,sizeof(char));
            strcpy(systemName,argv[argc-1]);
        }
    }

    /* Create the gui */
    viewImageGuiCreateWidgets(systemName);

    /* Start the main loop */
    viewImageGuiStartMainLoop();

    return 0;
}


/******************************************************
  printUsage
******************************************************/
static void printUsage(char *app)
{
    fprintf(stderr,"Usage: %s [Xoptions] system\n", app);
    fprintf(stderr,"where:\n");
    fprintf(stderr,"  system is a pv prefix such as SR:VD1, LI:VD1, S:VID1, etc.\n");
}
