/*************************************************************************\
* Copyright (c) 2002 The University of Chicago, as Operator of Argonne
* National Laboratory.
* Copyright (c) 2002 The Regents of the University of California, as
* Operator of Los Alamos National Laboratory.
* This file is distributed subject to a Software License Agreement found
* in the file LICENSE that is included with this distribution. 
\*************************************************************************/
/* viewImageCA.h */

#ifndef INCLimgCAh
#define INCLimgCAh

/* viewImageCA.h,v 1.4 2005/08/23 18:55:19 jba Exp */
/************************DESCRIPTION***********************************
  This file contains prototypes for channel access routines.
**********************************************************************/

#ifdef __cplusplus
extern "C" {
#endif

struct valueEventData {
   void (*pFunc)(void *);
   void *ptr;
};

void viewImageCaPendEvent(double waitSeconds);
short viewImageCaIsConnected(chid chid);
int viewImageCaPendIO(double waitSeconds);
void viewImageCaFlushIO();
void viewImageCaInit();
void viewImageCaPoll();
void viewImageCaSearchChannel(char *name,chid *pimageChid);
void viewImageCaClearChannel(chid * pchid);
void viewImageCaClearEvent(evid * pevid);
void viewImageCaAddValueEvent(int request_type,chid chid, evid * pevid,
                              void (*pFunc)(struct event_handler_args args));
int viewImageCaArrayGet(chtype type,unsigned long count,chid chid,void *pdata);
void viewImageCaPut(int type,chid chid, void *pvalue);
void viewImageCaClose();
void viewImageCaSgBlock(const CA_SYNC_GID gid, ca_real timeout);
void viewImageCaSgCreate(CA_SYNC_GID * pgid);
int viewImageCaSgArrayGet(CA_SYNC_GID gid,chtype type,unsigned long count,chid chid,void *pdata);
void viewImageCaSgDelete(const CA_SYNC_GID gid);
void viewImageCaSearchAndConnectChannel(char *name, chid * pchid,void (*pFunc)());
void viewImageCaAddConnectionHandler(chid chid,void (*pFunc)(void *));

#ifdef __cplusplus
}
#endif

#endif /* INCLimgCAh */

