/*************************************************************************\
* Copyright (c) 2002 The University of Chicago, as Operator of Argonne
* National Laboratory.
* Copyright (c) 2002 The Regents of the University of California, as
* Operator of Los Alamos National Laboratory.
* This file is distributed subject to a Software License Agreement found
* in the file LICENSE that is included with this distribution. 
\*************************************************************************/
/* viewImageData.h */

/* Id */
/**********************************************************************
  Image data prototypes.
**********************************************************************/

#ifndef INCLimgDatah
#define INCLimgDatah

#ifdef __cplusplus
extern "C" {
#endif

extern void viewImageDataCreateData(char *system);
extern  int viewImageDataGetImageWidth();
extern  int viewImageDataGetImageHeight();
extern  int viewImageDataGetXWidth();
extern  int viewImageDataGetXHeight();
extern  int viewImageDataGetImageX();
extern  int viewImageDataGetImageY();
extern  int viewImageDataGetImageArrayHeight();
extern  int viewImageDataGetImageArrayWidth();
extern  int viewImageDataGetImageArraySize();
extern  int viewImageDataGetImageArrayBits();
extern  int viewImageDataGetImageMaxValue();
extern  unsigned short viewImageDataGetImageMaxColors();
extern  unsigned char *viewImageDataGetImageArray();
extern  int viewImageDataDataIsModified();
extern  int viewImageDataReadImage();
extern void viewImageDataRequestImageUpdate();
extern void viewImageDataSetDisplayROIonly();
extern void viewImageDataDisconnect();
extern void viewImageDataCaClose();
extern  int viewImageDataUpdateImageIsConnected();
extern  int viewImageDataROIIsConnected();
extern unsigned char * viewImageDataGetColorRedArray();
extern unsigned char * viewImageDataGetColorBlueArray();
extern unsigned char * viewImageDataGetColorGreenArray();
extern int  viewImageDataColorTableIsModified();
extern void viewImageDataSetColorTableIsModified(int);
extern int  viewImageDataRoiIsConnected();
extern void viewImageDataSetRoi(int roiX,int roiY,int roiWidth,int roiHeight);
extern void viewImageDataGetRoi(int *proiX,int *proiY,int *proiWidth,int *proiHeight);
extern void viewImageDataSetSubRegionOnly(int value);
extern void viewImageDataSetSubRegion(int x,int y,int width,int height);
extern int viewImageDataGetImageMinValue();
extern int viewImageDataGetImageMaxValue();
extern int viewImageDataUpdateArrayMinMax();


#ifdef __cplusplus
}
#endif

#endif /* INCLimgDatah */

