/*************************************************************************\
* Copyright (c) 2002 The University of Chicago, as Operator of Argonne
* National Laboratory.
* Copyright (c) 2002 The Regents of the University of California, as
* Operator of Los Alamos National Laboratory.
* This file is distributed subject to a Software License Agreement found
* in the file LICENSE that is included with this distribution. 
\*************************************************************************/
/* viewImageSystem.c */

/* viewImageSystemDialog.c,v 1.2 2002/07/23 19:18:25 jba Exp */
/************************DESCRIPTION***********************************
  Creates system entry promptDialog
**********************************************************************/

#include <stdlib.h>
#include <stdio.h>
#include <stdarg.h>

#include <Xm/Xm.h>
#include <Xm/SelectioB.h>
#include <Xm/MessageB.h>

#include "viewImageGui.h"

/* globals */
extern Widget topLevelShell;

/******************************************************
  Static ok callback routine for setting sytstem name
******************************************************/
static void okCallback(Widget w, XtPointer clientdata, XtPointer calldata)
{
    XmSelectionBoxCallbackStruct *cbs=(XmSelectionBoxCallbackStruct *)calldata;
    char *value;

    XmStringGetLtoR(cbs->value,XmSTRING_DEFAULT_CHARSET, &value);
    if (strlen(value)>1) {
      XtUnmanageChild(w);
      viewImageGuiSetSystemName(value);
    }
}

/******************************************************
  Static cancel callback routine for removing promptDialog
******************************************************/
static void cancelCallback(Widget w, XtPointer clientdata, XtPointer calldata)
{
    XtUnmanageChild(w);
}


/******************************************************
  Static help routine for removing promptDialog
******************************************************/
static void helpCallback(Widget w, XtPointer clientdata, XtPointer calldata)
{
    static Widget systemMessageDialog=NULL;
    XmString string;
    char dialogName[]="helpDialog"; 
    char dialogTitle[]="viewImage: System Help Dialog"; 

  if (!systemMessageDialog) {

    systemMessageDialog=XmCreateMessageDialog(w,dialogName,NULL,0);

    string=XmStringCreateSimple("System is a pv prefix such as SR:VD1, LI:VD1, S:VID1, etc.");
    XtVaSetValues(systemMessageDialog,XmNmessageString,string,NULL);
    XmStringFree(string);

    XtVaSetValues(XtParent(systemMessageDialog),XmNtitle,dialogTitle,NULL);

    XtUnmanageChild(XmMessageBoxGetChild(systemMessageDialog,XmDIALOG_HELP_BUTTON));
    XtUnmanageChild(XmMessageBoxGetChild(systemMessageDialog,XmDIALOG_CANCEL_BUTTON));
    XtAddCallback(systemMessageDialog,XmNokCallback,cancelCallback,(XtPointer)NULL);
  }
    XtManageChild(systemMessageDialog);
}

/******************************************************
  Create the System Prompt Dialog
******************************************************/
void systemNameDialog()
{
    static Widget systemPromptDialog=NULL;
    XmString string;
    static char buff[]="Enter System:";
    char dialogName[]="systemNameDialog"; 
    char dialogTitle[]="viewImage: System Dialog"; 

  if (!systemPromptDialog) {

    systemPromptDialog=XmCreatePromptDialog(topLevelShell,dialogName,NULL,0);

    XtVaSetValues(XtParent(systemPromptDialog),XmNtitle,dialogTitle,NULL);

    string=XmStringCreateSimple(buff);
    XtVaSetValues(systemPromptDialog,XmNselectionLabelString,string,NULL);
    XmStringFree(string);

    XtAddCallback(systemPromptDialog,XmNokCallback,okCallback,(XtPointer)NULL);
    XtAddCallback(systemPromptDialog,XmNcancelCallback,cancelCallback,(XtPointer)NULL);
    XtAddCallback(systemPromptDialog,XmNhelpCallback,helpCallback,(XtPointer)NULL);
    XtManageChild(systemPromptDialog);
  }

  string=XmStringCreateSimple(viewImageGuiGetSystemName());
  XtVaSetValues(systemPromptDialog,XmNtextString,string,NULL);
  XmStringFree(string);
  XtManageChild(systemPromptDialog);
}


